import javax.microedition.lcdui.*;
import javax.microedition.io.file.*;
import javax.microedition.io.*;
import java.io.*;
import java.util.*;

//t@C̓ǂݏs[IvVAPI](tH[)
class FileConnectionForm extends Form
    implements ItemCommandListener {
    private String     path;               //݂̃pX
    private String     nextPath="file:///";//̃pX
    private TextField  textField;          //eLXgtB[h
    private StringItem btnWrite;           //݃{^
    private StringItem btnReturn;          //߂{^

    //RXgN^
    public FileConnectionForm(){
        super("");

        //eLXgtB[h
        textField=new TextField("","",10240,TextField.ANY);
        textField.setLayout(Item.LAYOUT_2|Item.LAYOUT_NEWLINE_AFTER);

        //݃{^
        btnWrite=new StringItem("","ۑ",Item.BUTTON);
        btnWrite.setDefaultCommand(new Command("ۑ",Command.SCREEN,2));
        btnWrite.setItemCommandListener(this);

		//߂{^
        btnReturn=new StringItem("","߂",Item.BUTTON);
        btnReturn.setDefaultCommand(new Command("߂",Command.SCREEN,2));
        btnReturn.setItemCommandListener(this);

        //fBNgJ
        openDir();
    }

    //ACeCxg
    public void commandAction(Command c,Item item)  {
        //O
        String name="..";
        if (item!=btnWrite && item!=btnReturn) {
        	name=((StringItem)item).getText();
		}

        //efBNg̃pX
        if (name.equals("..")) {
            int pos=path.lastIndexOf('/',path.length()-2);
            nextPath=path.substring(0,pos+1);
        }
        //qfBNgƃt@C̃pX
        else {
            nextPath=path+name;
        }

    	//eLXgt@C̏
    	if (item==btnWrite) {
            Thread thread=new Thread() {
                public void run() {writeText();}
            };
            thread.start();
    	}
        //eLXgt@C̓ǂݍ
        else if (name.toLowerCase().endsWith(".txt")) {
            Thread thread=new Thread() {
                public void run() {readText();}
            };
            thread.start();
        }
        //fBNgJ
        else if (nextPath.endsWith("/")) {
            Thread thread=new Thread() {
                public void run() {openDir();}
            };
            thread.start();
        }    
    }

    //ACe̒ǉ
    private void addItem(String text) {
        StringItem item=new StringItem("",text);
        item.setLayout(Item.LAYOUT_2|Item.LAYOUT_NEWLINE_AFTER);
        item.setDefaultCommand(new Command(text,Command.SCREEN,2));
        item.setItemCommandListener(this);
        append(item);
    }

    //fBNgJ
    private void openDir() {
        Enumeration enm=null;

        //[g̃fBNgƃt@C̎擾
        if (nextPath.equals("file:///")) {
            enm=FileSystemRegistry.listRoots();
        }
        //fBNg̃fBNgƃt@C̎擾
        else {
            try {
                FileConnection fc=(FileConnection)
                    Connector.open(nextPath,Connector.READ);
                enm=fc.list();
            } catch (Exception e) {
                return;
            }
        }

        //fBNgƃt@C̕\
        setTitle(nextPath);
        deleteAll();
        while (enm.hasMoreElements()) {
            addItem((String)enm.nextElement());
        }
        if (!nextPath.equals("file:///")) addItem("..");
        path=nextPath;
    }

    //eLXgt@C̓ǂݍ
    private void readText() {
        InputStream in  =null;
        String      text="";
        try {
            //[̃t@C̓ǂݍ
            FileConnection fc=(FileConnection)
            	Connector.open(nextPath,Connector.READ);
            in=fc.openInputStream();
            byte[] w=new byte[10240];//ő10K
            int size=in.read(w);
            in.close();
            textField.setString(new String(w,0,size));
        } catch (Exception e) {
            try {
                if (in!=null) in.close();
            } catch (Exception e2) {
            }
            textField.setString("");
        }

        //eLXg̕\
        setTitle(nextPath);
        deleteAll();
        append(textField);
        append(btnWrite);
        append(btnReturn);
        path=nextPath;
    }
    
    //eLXgt@C̏
    private void writeText() {
        OutputStream out=null;
        try {
            //[̃t@C̏
            FileConnection fc=(FileConnection)
            	Connector.open(path,Connector.WRITE);
            out=fc.openOutputStream();
            out.write(textField.getString().getBytes());
            out.close();
        } catch (Exception e) {
            try {
                if (out!=null) out.close();
            } catch (Exception e2) {
            }
        }

        //fBNgJ
        openDir();
    }
}