import javax.microedition.lcdui.*;
import javax.microedition.rms.*;

//R[hXgA̓ǂݏ(tH[)
class RecordStoreForm extends Form 
	implements ItemCommandListener  {
    private TextField  textField;//eLXgtB[h
    private StringItem btnRead;  //ǂݍ݃{^
    private StringItem btnWrite; //݃{^

    //RXgN^
    RecordStoreForm(){
        super("RecordStoreEx");

        //eLXgtB[h
        textField=new TextField("","",255,TextField.ANY);
        textField.setLayout(Item.LAYOUT_2|Item.LAYOUT_NEWLINE_AFTER);
        append(textField);

        //ǂݍ݃{^
        btnRead=new StringItem("","Ǎ",Item.BUTTON);
        btnRead.setDefaultCommand(new Command("Ǎ",Command.SCREEN,2));
        btnRead.setItemCommandListener(this);
        append(btnRead);

        //݃{^
        btnWrite=new StringItem("","",Item.BUTTON);
        btnWrite.setDefaultCommand(new Command("",Command.SCREEN,2));
        btnWrite.setItemCommandListener(this);
        append(btnWrite);

        //R[hXgȀ
        initRecordStore();
    }

    //ACeCxg
    public void commandAction(Command c,Item item)  {
        //ǂݍ݃{^
        if (item==btnRead) {
        	textField.setString(readRecordStore());
        }

        //݃{^
        if (item==btnWrite) {
        	writeRecordStore(textField.getString());
        }
    }

    //R[hXgȀ
    private synchronized void initRecordStore() {
        RecordStore rs=null;
        try {
            //R[hXgȀ
            rs=RecordStore.openRecordStore("test",true);
            if (rs.getNumRecords()==0) {
                rs.addRecord(new byte[255],0,255);
            }
            rs.closeRecordStore();
        } catch (Exception e) {
            //O
            try {
                if (rs!=null) rs.closeRecordStore();
            } catch (Exception e2) {
            }
            showErrorDialog("R[hXgAs܂B");
        }
    }

    //R[hXgȀ
    private synchronized void writeRecordStore(String str) {
        byte[] w=null;
        byte[] data=new byte[1];
        RecordStore rs=null;
        try {
            //oCgf[^ɕϊ
            w=str.getBytes();
            if (w==null || w.length<=0 || 255<w.length) {
            	data=new byte[0];
            } else {
            	data=new byte[1+w.length];
            	data[0]=(byte)w.length;
            	System.arraycopy(w,0,data,1,w.length);
            }

            //R[hXgȀ
            rs=RecordStore.openRecordStore("test",true);
            rs.setRecord(1,data,0,data.length);
            rs.closeRecordStore();
        } catch (Exception e) {
            //O
            try {
                if (rs!=null) rs.closeRecordStore();
            } catch (Exception e2) {
            }
            showErrorDialog("R[hXgA݂s܂B");
        }
    }

    //R[hXgA̓ǂݍ
    private synchronized String readRecordStore() {
        byte[] w;
        byte[] data=new byte[1024];
        RecordStore rs=null;
        try {
            //R[hXg̓ǂݍ
            rs=RecordStore.openRecordStore("test",false);
            data=rs.getRecord(1);
            rs.closeRecordStore();

            //oCgf[^𕶎ɕϊ
            w=new byte[data[0]&0xFF];
            System.arraycopy(data,1,w,0,w.length);
            return new String(w);
        } catch (Exception e) {
            //O
            try {
                if (rs!=null) rs.closeRecordStore();
            } catch (Exception e2) {
            }
            showErrorDialog("R[hXgAǂݍ݂s܂B");
        }
        return "";
    }

    //G[_CAO̕\
    private void showErrorDialog(String text) {
        Alert alert=new Alert("G[",text,null,AlertType.ERROR);
        alert.setTimeout(Alert.FOREVER);
        (Display.getDisplay(RecordStoreEx.midlet)).setCurrent(alert);
    }
}