import javax.microedition.lcdui.*;
import javax.microedition.media.*;
import javax.microedition.media.control.*;
import java.io.*;

//TEhĐ(tH[)
class SoundForm extends Form
    implements ItemCommandListener {
    private Gauge      gauge;  //Q[W
    private StringItem btnPlay;//Đ{^
    private StringItem btnStop;//~{^
    private Player     player; //vC[

    //RXgN^
    public SoundForm(){
        super("SoundEx");

        //Q[W
        gauge=new Gauge("{[",true,10,10);
        gauge.setLayout(Item.LAYOUT_2|Item.LAYOUT_NEWLINE_AFTER);
        append(gauge);

        //Đ{^
        btnPlay=new StringItem("","Đ",Item.BUTTON);
        btnPlay.setDefaultCommand(new Command("Đ",Command.SCREEN,2));
        btnPlay.setItemCommandListener(this);
        append(btnPlay);

        //~{^
        btnStop=new StringItem("","~",Item.BUTTON);
        btnStop.setDefaultCommand(new Command("~",Command.SCREEN,2));
        btnStop.setItemCommandListener(this);
        append(btnStop);

        //TEht@C̓ǂݍ
        try {
            InputStream in=getClass().getResourceAsStream("/sound.mid");
            player=Manager.createPlayer(in,"audio/midi");
            player.prefetch();
        } catch (Exception e) {
            System.out.println(e.toString());
        }
    }

    //ACeCxg
    public void commandAction(Command c,Item item)  {
        //Đ{^
        if (item==btnPlay) {
            try {
                //{[w
                VolumeControl vc=(VolumeControl)
                    player.getControl("VolumeControl");
                vc.setLevel(gauge.getValue()*10);

                //Đ
                player.start();
            } catch (Exception e) {
            }
        }
        //~{^
        if (item==btnStop) {
            try {
                //~
                player.stop();
            } catch (Exception e) {
            }
        }
    }
}